// oop_ex117.cpp
// virtual bases and constructors

#include <iostream>

using namespace std;

//-----X-----------------

class X
{
	int x;
public:
	X(int xx) : x(xx) { }
	virtual void print()
	{
		cout << "The value of x of X sub-object: " << x << endl;
	}
};

//-----Y-----------------

//class Y : public X
class Y : virtual public X
{
	int y;
public:
	Y(int xx, int yy) : X(xx), y(yy) { }	 //X(xx) will be ignored when invoked by the constructors of Z
	virtual void print()
	{
		X::print();
		cout << "The value of y of Y sub-object: " << y << endl;
	}
};


//-----T-----------------

//class T : public X
class T : virtual public X
{
	int t;
public:
	T(int xx, int tt) : X(xx), t(tt) { } //X(xx) will be ignored when invoked by the constructors of U
	virtual void print()
	{
		X::print();
		cout << "The value of t of T sub-object: " << t << endl;
	}
};

//-----Z-----------------

class Z : public Y
{
	int z;
public:
	Z(int xx, int yy, int zz) : Y(xx, yy), X(xx), z(zz) { } //X(xx) must be invoked explicitly
	virtual void print()
	{
		Y::print();
		cout << "The value of z of Z sub-object: " << z << endl;
	}
};

//-----W-----------------

class W : public Z
{
	int w;
public:
	W(int xx, int yy, int zz, int ww) 
		: Z(xx, yy, zz), X(xx), w(ww) { } //X(xx) must be invoked explicitly
	virtual void print()
	{
		Z::print();
		cout << "The value of w of W sub-object: " << w << endl;
	}
};

//-----U-----------------

class U : public W, public T
{
	int u;
public:
	U(int xx, int yy, int zz, int ww, int tt, int uu)
		: W(xx, yy, zz, ww), T(xx, tt), X(xx), u(uu) { } //X(xx) must be invoked explicitly
	virtual void print()
	{
		X::print();	//this is OK now!
		W::print();
		T::print();
		cout << "The value of u of U sub-object: " << u << endl;
	}
};

//-----main()--------------

void main()
{
	cout << "X object coming up: " << endl;
	X xobj(1);
	xobj.print();
	cout << endl;

	cout << "Y object coming up: " << endl;
	Y yobj(11, 22);
	yobj.print();
	cout << endl;

	cout << "Z object coming up: " << endl;
	Z zobj(111, 222, 333);
	zobj.print();
	cout << endl;

	cout << "W object coming up: " << endl;
	W wobj(1111, 2222, 3333, 4444);
	wobj.print();
	cout << endl;

	cout << "T object coming up: " << endl;
	T tobj(11111, 55555);
	tobj.print();
	cout << endl;

	cout << "U object coming up: " << endl;
	U uobj(111111, 222222, 333333, 444444, 555555, 666666);
	uobj.print();
	cout << endl;

	X* xptr = &uobj;	// U "isA" X

	system("pause");
}