// oop_ex118.cpp
// diamond hierarchy with virtual base


#include <iostream>
#include <string>

using namespace std;


class Person
{
protected:
	string name;
	Person(string n)
	{
		name = n;
	}

	void print()
	{
		cout << "Person name = " << name << endl;
	}
};

class Staff : virtual public Person
{
private:
	string dept;
protected:
	double salary;
public:
	Staff(string n, string d, double s) : Person(n)
	{
		dept = d;
		salary = s;
	}

	void setDept(string d) { dept = d; }
	string getDept() { return dept; }

	void print()
	{
		Person::print();
		cout << "Staff name = " << name << endl;
		cout << ",who works in " << dept << " ";
		cout << ",whose salary is " << salary << endl << endl;
	}
};


class Student : virtual public Person
{
private:
	string dept;
protected:
	string level;
public:
	Student(string n, string d, string l) : Person(n)
	{
		dept = d;
		level = l;
	}

	void setDept(string d) { dept = d; }
	string getDept() { return dept; }

	void print()
	{
		Person::print();
		cout << "Student name = " << name << endl;
		cout << ",who studies in " << dept << " ";
		cout << ",whose level is " << level << endl << endl;
	}
};


class TA : public Staff, public Student
{
private:
	string course;
public:
	TA(string n, string wd, double s, string sd, string l, string c)
		: Staff(n, wd, s), Student(n, sd, l), Person(n)
	{
		course = c;
	}

	void setCourse(string c) { course = c; }
	string getCourse() { return course; }

	void print()
	{
		Person::print();		//OK now

		cout << "TA name = " << name << endl;					//OK now
		cout << "TA name = " << Person::name << endl;		//OK now
		cout << "TA name = " << Student::name << endl;	//OK

		//cout<<",who is in = " << getDept() <<endl;		//'getDept()' is ambiguous
		cout << ",who studies in " << Student::getDept() << " ";
		cout << ",whose level is " << level << endl;

		cout << ",who works in " << Staff::getDept() << " ";
		cout << ",whose salary is " << salary << " ";
		cout << ",who works for course " << course << endl << endl;
	}
};

void main()
{
	Staff p1("John", "ME", 10000);
	Student p2("Mike", "CS", "Senior");
	TA p3("Paul", "CT", 6000, "AD", "PhD", "CT5706");

	p1.print();
	p2.print();
	p3.print();

	Person* p = &p3;   // "isA" is OK now

	system("pause");
}