// oop_ex121n.cpp
// mixin classes


#include <iostream>
#include <string>

using namespace std;

//mixin class
class Work
{
public:
	virtual void setDept(string d) = 0;
	virtual string getDept() = 0;
};

class Study
{
public:
	virtual void setStdDept(string d) = 0;
	virtual string getStdDept() = 0;
	//virtual void setDept(string d) = 0;
	//virtual string getDept() = 0;
};

//base class
class Person
{
protected:
	string name;
public:
	Person(string n)
	{
		name = n;
	}

	virtual void print()
	{
		cout << "Person name = " << name << endl;
	}
};

class Staff : public Person, public Work
{
private:
	string dept;
protected:
	double salary;
public:
	Staff(string n, string d, double s) : Person(n), Work()
	{
		dept = d;
		salary = s;
	}

	void setDept(string d) { dept = d; }
	string getDept() { return dept; }

	void print()
	{
		Person::print();
		cout << "Staff name = " << name << endl;
		cout << ",who works in " << dept << " ";
		cout << ",whose salary is " << salary << endl << endl;
	}
};


class Student : public Person, public Study
{
private:
	string dept;
protected:
	string level;
public:
	Student(string n, string d, string l) : Person(n), Study()
	{
		dept = d;
		level = l;
	}

	void setStdDept(string d) { dept = d; }
	string getStdDept() { return dept; }
	//void setDept(string d){ dept = d; }
	//string getDept(){ return dept; }

	void print()
	{
		Person::print();
		cout << "Student name = " << name << endl;
		cout << ",who studies in " << dept << " ";
		cout << ",whose level is " << level << endl << endl;
	}
};


class TA : public Student, public Work
{
private:
	string course;
	string dept;
protected:
	double salary;
public:
	TA(string n, string wd, double s, string sd, string l, string c)
		: Student(n, sd, l), Work()
	{
		dept = wd;
		salary = s;
		course = c;
	}

	void setDept(string d) { dept = d;  }
	string getDept() { return dept; }

	void setCourse(string c) { course = c; }
	string getCourse() { return course; }

	void print()
	{
		cout << "TA name = " << name << endl;

		cout << ",who studies in " << getStdDept() << " ";
		//cout<<",who studies in " << Student::getDept() <<" ";
		cout << ",whose level is " << level << endl;

		cout << ",who works in " << getDept() << " ";
		cout << ",whose salary is " << salary << " ";
		cout << ",who works for course " << course << endl << endl;
	}
};

void main()
{
	int i;
	Staff p1("John", "ME", 10000);
	Student p2("Mike", "CS", "Senior");
	TA p3("Paul", "CT", 6000, "AD", "PhD", "CT5706");

	Person* p[3] = { &p1, &p2, &p3 };
	for (i = 0; i<3; i++)
		p[i]->print();

	Work* w[2] = { &p1, &p3 };
	for (i = 0; i<2; i++)
		cout << "I work in " << w[i]->getDept() << endl;

	Study* s[2] = { &p2, &p3 };
	for (i = 0; i<2; i++)
		cout << "I study in " << s[i]->getStdDept() << endl;

	system("pause");
}