//oop_ex121r.cpp
//Mixin classes
//Revised version of oop_ex121.cpp

#include <iostream>
#include<string>

using namespace std;

//Mixin classes
class printable
{
public:
	virtual void print() = 0;
	virtual void printToFile(string filename) = 0;
};

class scaleable
{
public:
	virtual void scale(int f) = 0;
};



//abstract base class
class shape
{
	double x, y;
public:
	virtual void move(int x, int y) = 0;
	virtual void draw() = 0;
};




//concrete derived classes
class circle : public shape, public printable
{
public:
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }

	void print() { cout << "do print circle" << endl; }
	void printToFile(string filename) { cout << "do print circle on " << filename << endl; }
};


class triangle : public shape, public scaleable
{
public:
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }

	void scale(int f) { cout << "do scale triangle by " << f << endl; }
};


class square : public triangle
{
public:
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }

	void scale(int f) { cout << "do scale square by " << f << endl; }
};


void main()
{
	int i;
	circle* ci = new circle();
	triangle* tr = new triangle();
	square* sq = new square();

	shape* shapeArr[] = { ci, tr, sq };

	for (i = 0; i<3; i++)
		shapeArr[i]->draw();

	for (i = 0; i<3; i++)
		shapeArr[i]->move(i + 1, i + 1);

	//for(i=0; i<3; i++)
	//	shapeArr[i]->print(); 

	//for(i=0; i<3; i++)
	//	shapeArr[i]->printToFile("out.txt");

	printable* p = ci;
	p->print();
	p->printToFile("out.txt");

	//for(i=0; i<3; i++)
	//	shapeArr[i]->scale(i+1);

	scaleable* tArr[] = { tr, sq };

	for (i = 0; i<2; i++)
		tArr[i]->scale(i + 1);

	system("pause");
}