// oop_ex123n.cpp
// role playing classes


#include <iostream>
#include <string>

using namespace std;

//role playing classes
class Ability
{
public:
	virtual ~Ability() {}  //try to quote this line, what happey?
};


class Work : public Ability
{
private:
	string dept;
public:
	double salary;
	Work(string d, double s)
	{
		dept = d;
		salary = s;
	}
	virtual void setDept(string d) { dept = d;  }
	virtual string getDept() { return dept; }
};


class Study : public Ability
{
private:
	string dept;
public:
	string level;
	Study(string d, string l)
	{
		dept = d;
		level = l;
	}
	virtual void setStdDept(string d) { dept = d; }
	virtual string getStdDept() { return dept; }
};


//base class
class Person
{
protected:
	string name;
public:
	Ability * ab1;
	Ability* ab2;
	Person(string n)
	{
		name = n;
		ab1 = 0;
		ab2 = 0;
	}

	virtual void print()
	{
		cout << "Person name = " << name << endl;
	}
};


//derived class
class Staff : public Person
{
public:
	Staff(string n, string d, double s) : Person(n)
	{
		ab1 = new Work(d, s);
		ab2 = 0;
	}


	void print()
	{
		cout << "Staff name = " << name << endl;

		Work* p1 = static_cast<Work*>(ab1);	//It is known ab1 points to a Work object, so use static cast.
		cout << ",who works in " << p1->getDept() << " ";
		cout << ",whose salary is " << p1->salary << endl << endl;
	}
};


class Student : public Person
{
public:
	Student(string n, string d, string l) : Person(n)
	{
		ab1 = new Study(d, l);
		ab2 = 0;
	}


	void print()
	{
		cout << "Student name = " << name << endl;

		Study* p1 = static_cast<Study*>(ab1); //It is known ab1 points to a Study object, so use static cast.
		cout << ",who studies in " << p1->getStdDept() << " ";
		cout << ",whose level is " << p1->level << endl << endl;
	}
};


class TA : public Person
{
private:
	string course;
public:
	TA(string n, string wd, double s, string sd, string l, string c)
		: Person(n)
	{

		ab1 = new Work(wd, s);
		ab2 = new Study(sd, l);
		course = c;
	}


	void print()
	{
		cout << "TA name = " << name << endl;

		Study* p2 = static_cast<Study*>(ab2); //It is known ab2 points to a Study object, so use static cast.
		cout << ",who studies in " << p2->getStdDept() << " ";
		cout << ",whose level is " << p2->level << endl;

		Work* p1 = static_cast<Work*>(ab1);	//It is known ab1 points to a Work object, so use static cast.
		cout << ",who works in " << p1->getDept() << " ";
		cout << ",whose salary is " << p1->salary << " ";

		cout << ",who works for course " << course << endl << endl;
	}
};

void main()
{
	int i;
	Staff p1("John", "ME", 10000);
	Student p2("Mike", "CS", "Senior");
	TA p3("Paul", "CT", 6000, "AD", "PhD", "CT5706");

	Person* p[3] = { &p1, &p2, &p3 };
	for (i = 0; i<3; i++)
		p[i]->print();


	for (i = 0; i<3; i++)
	{
		Work* ab = dynamic_cast<Work*>(p[i]->ab1);
		if (ab != 0)
			cout << "I work in " << ab->getDept() << endl;

		ab = dynamic_cast<Work*>(p[i]->ab2);
		if (ab != 0)
			cout << "I work in " << ab->getDept() << endl;
	}


	for (i = 0; i<3; i++)
	{
		Study* ab = dynamic_cast<Study*>(p[i]->ab1);
		if (ab != 0)
			cout << "I study in " << ab->getStdDept() << endl;

		ab = dynamic_cast<Study*>(p[i]->ab2);
		if (ab != 0)
			cout << "I study in " << ab->getStdDept() << endl;
	}

	system("pause");
}