//oop_ex123r.cpp
//Role Playing classes
//Revised version of oop_ex123.cpp

#include <iostream>
#include<string>

using namespace std;

//Role Playing classes

class ability
{
public:
	virtual ~ability() {};	//try to quote this line, what happen?
};

class printable : public ability
{
public:
	virtual void print(string c) { cout << "do print " << c << endl; }
	virtual void printToFile(string c, string filename)
	{
		cout << "do print " << c << " on " << filename << endl;
	}
};

class scaleable : public ability
{
public:
	virtual void scale(string c, int f) { cout << "do scale " << c << " by " << f << endl; };
};



//abstract base class
class shape
{
	double x, y;
protected:
	ability * ab;
public:
	virtual void move(int x, int y) = 0;
	virtual void draw() = 0;
	virtual string getType() = 0;
	virtual ability* getAbility() { return ab; }
};



//concrete derived classes
class circle : public shape
{
public:
	circle()
	{
		ab = new printable();
	}

	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
	string getType() { return "circle"; }
};


class triangle : public shape
{
public:
	triangle()
	{
		ab = new scaleable();
	}
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
	string getType() { return "triangle"; }
};


class square : public triangle
{
public:
	square()
	{
		ab = new scaleable();
	}
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
	string getType() { return "square"; }
};


void main()
{
	int i;
	circle* ci = new circle();
	triangle* tr = new triangle();
	square* sq = new square();

	shape* shapeArr[] = { ci, tr, sq };

	for (i = 0; i<3; i++)
		shapeArr[i]->draw();

	for (i = 0; i<3; i++)
		shapeArr[i]->move(i + 1, i + 1);

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();
		printable* p = dynamic_cast<printable*>(ab);
		if (p != 0)
			p->print(shapeArr[i]->getType());
	}

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();
		printable* p = dynamic_cast<printable*>(ab);
		if (p != 0)
			p->printToFile(shapeArr[i]->getType(), "out.txt");
	}

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();
		scaleable* p = dynamic_cast<scaleable*>(ab);
		if (p != 0)
			p->scale(shapeArr[i]->getType(), i + 1);
	}

	system("pause");
}