//oop_ex124.cpp
//typeid of RTTI

#include <iostream>
#include <typeinfo>		//needed for typeid
//#include <typeinfo.h>	//not existed anymore
#include <string>

using namespace std;

//Role Playing classes

class ability
{
public:
	virtual ~ability() {};
};

class printable : public ability
{
public:
	virtual void print(string c) { cout << "do print " << c << endl; }
	virtual void printToFile(string c, string filename)
	{
		cout << "do print " << c << " on " << filename << endl;
	}
};

class printandscaleable : public printable
{
public:
	virtual void scale(string c, int f) { cout << "do scale " << c << " by " << f << endl; };
};



//abstract base class
class shape
{
	double x, y;
protected:
	ability * ab;
public:
	virtual void move(int x, int y) = 0;
	virtual void draw() = 0;
	virtual string getType() = 0;
	virtual ability* getAbility() { return ab; }
};



//concrete derived classes
class circle : public shape
{
public:
	circle()
	{
		ab = new printable();
	}

	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
	string getType() { return "circle"; }
};


class triangle : public shape
{
public:
	triangle()
	{
		ab = new printandscaleable();
	}
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
	string getType() { return "triangle"; }
};


class square : public triangle
{
public:
	square()
	{
		ab = new printandscaleable();
	}
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
	string getType() { return "square"; }
};


void main()
{
	int i;
	circle* ci = new circle();
	triangle* tr = new triangle();
	square* sq = new square();

	shape* shapeArr[] = { ci, tr, sq };

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();

		//if(typeid(*(shapeArr[i]->getAbility())) == typeid(printable))
		if (typeid(*(ab)) == typeid(printable))
		{
			cout << "typeid test: shape[" << i << "] has print ability" << endl;
			string type = typeid(*(ab)).name();
			cout << "   it is of type : " << type << endl;
		}

		printable* p = dynamic_cast<printable*>(ab);
		if (p != 0)
			p->print(shapeArr[i]->getType());


	}

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();

		if (typeid(*(shapeArr[i]->getAbility())) == typeid(printable))
			//if(typeid(*(ab)) == typeid(printable))
		{
			cout << "typeid test: shape[" << i << "] has print ability" << endl;
			string type = typeid(*(ab)).name();
			cout << "   it is of type : " << type << endl;
		}

		printable* p = dynamic_cast<printable*>(ab);
		if (p != 0)
			p->printToFile(shapeArr[i]->getType(), "out.txt");
	}

	for (i = 0; i<3; i++)
	{
		ability* ab = shapeArr[i]->getAbility();

		//if(typeid(*(shapeArr[i]->getAbility())) == typeid(printable))
		if (typeid(*(ab)) == typeid(printandscaleable))
		{
			cout << "typeid test: shape[" << i << "] has print and scale ability" << endl;
			string type = typeid(*(ab)).name();
			cout << "   it is of type : " << type << endl;
		}

		printandscaleable* p = dynamic_cast<printandscaleable*>(ab);
		if (p != 0)
			p->scale(shapeArr[i]->getType(), i + 1);
	}

	system("pause");
}